// MapEditorView.cpp : CMapEditorView NX̎
//

#include "stdafx.h"
#include "MapEditor.h"

#include "MapEditorDoc.h"
#include "MapEditorView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// CMapEditorView

IMPLEMENT_DYNCREATE(CMapEditorView, CView)

BEGIN_MESSAGE_MAP(CMapEditorView, CView)
	ON_WM_LBUTTONDOWN()
	ON_WM_ERASEBKGND()
	ON_WM_LBUTTONUP()
	ON_WM_MOUSEMOVE()
END_MESSAGE_MAP()

// CMapEditorView RXgNV/fXgNV

CMapEditorView::CMapEditorView()
{
	// TODO: \zR[hɒǉ܂B
	m_bLeftButton = false;
	m_pPrevious = CPoint(-1,-1);
}

CMapEditorView::~CMapEditorView()
{
}

BOOL CMapEditorView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: ̈ʒu CREATESTRUCT cs C Window NX܂̓X^C
	//  CĂB

	return CView::PreCreateWindow(cs);
}

// CMapEditorView `

void CMapEditorView::OnDraw(CDC* pDC)
{
	CMapEditorDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	if (!pDoc)
		return;

	// TODO: ̏ꏊɃlCeBu f[^p̕`R[hǉ܂B
    CRect rect; 
	GetClientRect(&rect);

	//zfoCXReLXg쐬
	CDC memDC;
	memDC.CreateCompatibleDC(pDC);

    //zfoCXReLXgprbg}bv쐬
    CBitmap memBmp;
    memBmp.CreateCompatibleBitmap(pDC,rect.Width(),rect.Height());

    //zfoCXReLXgɃrbg}bvݒ
    CBitmap* memOldBmp = memDC.SelectObject(&memBmp);

    //wiɂ
    memDC.FillSolidRect(&rect,RGB(0,0,0));

	//}`
	DrawMap(&memDC);

	//`
	pDC->BitBlt(0,0,rect.Width(),rect.Height(),&memDC,0,0,SRCCOPY);
    //zfoCXReLXg̃rbg}bv
    memDC.SelectObject(memOldBmp);

    //zfoCXReLXg̃rbg}bvp
    memBmp.DeleteObject();
}

void CMapEditorView::DrawMap(CDC* memDC)
{
	CMapEditorDoc* pDoc = GetDocument();

	for ( int x = 0; x < MAP_WIDTH; x++ )
	{
		for ( int y = 0; y < MAP_HEIGHT; y++ )
		{
			if ( pDoc->map[y*MAP_WIDTH+x] )
			{
				memDC->FillSolidRect(
					x*CHIP_SIZE,
					y*CHIP_SIZE,
					CHIP_SIZE,
					CHIP_SIZE,
					0xffffff);
			}
		}
	}
}

// CMapEditorView ff

#ifdef _DEBUG
void CMapEditorView::AssertValid() const
{
	CView::AssertValid();
}

void CMapEditorView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CMapEditorDoc* CMapEditorView::GetDocument() const // fobOȊÕo[W̓CCłB
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CMapEditorDoc)));
	return (CMapEditorDoc*)m_pDocument;
}
#endif //_DEBUG


// CMapEditorView bZ[W nh

BOOL CMapEditorView::OnEraseBkgnd(CDC* pDC)
{
	// TODO: ɃbZ[W nh R[hǉ邩ȀĂяo܂B

	return FALSE;
}

void CMapEditorView::OnLButtonDown(UINT nFlags, CPoint point)
{
	// TODO: ɃbZ[W nh R[hǉ邩ȀĂяo܂B
	if ( !m_bLeftButton )
	{
		SetCapture();
	}

	m_bLeftButton = true;

	OnMouseMove(nFlags, point);

	CView::OnLButtonDown(nFlags, point);
}

void CMapEditorView::OnLButtonUp(UINT nFlags, CPoint point)
{
	// TODO: ɃbZ[W nh R[hǉ邩ȀĂяo܂B
	m_bLeftButton = false;

	m_pPrevious = CPoint(-1,-1);

	ReleaseCapture();

	CView::OnLButtonUp(nFlags, point);
}

void CMapEditorView::OnMouseMove(UINT nFlags, CPoint point)
{
	// TODO: ɃbZ[W nh R[hǉ邩ȀĂяo܂B
	if ( m_bLeftButton )
	{
		int x = point.x/CHIP_SIZE;
		int y = point.y/CHIP_SIZE;

		if ( m_pPrevious != CPoint(x,y) &&
			x > 0 && y > 0 && x < MAP_WIDTH-1 && y < MAP_HEIGHT-1 )
		{
			CMapEditorDoc* pDoc = GetDocument();
			pDoc->map[y*MAP_WIDTH+x] = !pDoc->map[y*MAP_WIDTH+x];
			pDoc->SetModifiedFlag();
			Invalidate();
		}
		m_pPrevious = CPoint(x,y);
	}
	CView::OnMouseMove(nFlags, point);
}

void CMapEditorView::OnInitialUpdate()
{
	CView::OnInitialUpdate();

	// TODO: ɓȃR[hǉ邩A͊{NXĂяoĂB
	SetClientSize(MAP_WIDTH*CHIP_SIZE,MAP_HEIGHT*CHIP_SIZE);
}

void CMapEditorView::SetClientSize(int w, int h) 
{ 
	CWnd* pParent = GetParent(); 

	pParent->SetWindowPos(0, 0, 0, 1000, 1000, 
	SWP_NOZORDER | SWP_NOMOVE | SWP_NOREDRAW); 

	CRect rc; GetClientRect(&rc); 

	int w2 = 1000 - rc.Width() + w; 
	int h2 = 1000 - rc.Height() + h; 

	pParent->SetWindowPos(0, 0, 0, 
	w2, h2, SWP_NOZORDER | SWP_NOMOVE); 
} 
